<template>
  <ContentWrap>
    <!-- 搜索工作栏 -->
    <el-form
      class="-mb-15px"
      :model="queryParams"
      ref="queryFormRef"
      :inline="true"
      label-width="68px"
    >
      <el-form-item label="月嫂姓名" prop="yuesaoId">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入月嫂姓名"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item label="月嫂ID" prop="yuesaoId">
        <el-input
          v-model="queryParams.id"
          placeholder="请输入月嫂ID"
          clearable
          @keyup.enter="handleQuery"
          class="!w-240px"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">
          <Icon icon="ep:search" class="mr-5px"/>
          搜索
        </el-button>
        <el-button @click="resetQuery">
          <Icon icon="ep:refresh" class="mr-5px"/>
          重置
        </el-button>
        <el-button
          type="primary"
          plain
          @click="openForm('create')"
        >
          <Icon icon="ep:plus" class="mr-5px"/>
          新增
        </el-button>
        <el-button
          plain
          @click="downloadTemplate"
        >
          <Icon icon="ep:download" class="mr-5px"/>
          下载导入模版
        </el-button>
        <!--				<el-button-->
        <!--					type="success"-->
        <!--					plain-->
        <!--					@click="handleExport"-->
        <!--					:loading="exportLoading"-->
        <!--				>-->
        <!--					<Icon icon="ep:download" class="mr-5px"/>-->
        <!--					导出-->
        <!--				</el-button>-->
        <el-upload
          :action="getRequestUrl('/admin-api/yuesao/yuesao/import')" :show-file-list="false"
          :on-success="handleImportSuccess"
          :headers="HEADERS"
          accept=".xls,.xlsx"

        >
          <template #trigger>
            <el-button
              style="margin: 0 0 0 12px"
              type="success"
              plain
            >
              <Icon icon="ep:upload" class="mr-5px"/>
              批量导入
            </el-button>
          </template>
        </el-upload>

      </el-form-item>
    </el-form>
  </ContentWrap>

  <!-- 列表 -->
  <ContentWrap>
    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="false"
              style="height: 600px">
      <el-table-column label="ID" align="center" prop="id" fixed="left"/>
      <el-table-column label="月嫂姓名" align="center" prop="name" fixed="left"/>
      <el-table-column label="月嫂头像" align="center" prop="avatar" fixed="left">
        <template #default="{row}">
          <viewer :images="[row.avatar]">
            <img v-if="row.avatar" :src="row.avatar"
                 style="width: 60px; height: 60px; object-fit: cover;"/>
            <img v-else src="http://43.138.81.125:8009/i/user/default-avatar.png"
                 style="width: 60px; height: 60px; object-fit: cover;"/>
          </viewer>
        </template>
      </el-table-column>
      <el-table-column label="注册手机号" align="center" prop="mobile"/>
      <el-table-column label="联系手机号" align="center" prop="mobileTel"/>
      <el-table-column label="微信号" align="center" prop="wechat"/>
      <el-table-column label="学历" align="center" prop="schoolDegreeValue"/>
      <!--      <el-table-column label="工作历史" align="center" prop="workHistory" />-->
      <!--      <el-table-column label="工作技能" align="center" prop="workSkill" />-->
      <el-table-column label="期望薪资" align="center" prop="expectedSalary"/>
      <el-table-column label="年龄" align="center" prop="age"/>
      <el-table-column label="籍贯" align="center" prop="origin"/>
      <el-table-column label="子女数" align="center" prop="hasChildren"/>
      <el-table-column label="从业时长年" align="center" prop="workYear"/>
      <el-table-column label="民族" align="center" prop="nation"/>
      <el-table-column label="自我介绍" align="center" prop="selfIntro"/>
      <el-table-column label="个人标签" width="300" align="center" prop="selfRemarksArray">
        <template #default="{row}">
          <el-tag v-for="(tag, i) in row.selfRemarksArray" :key="i" style="margin-right: 5px">{{
              tag
            }}
          </el-tag>
        </template>
      </el-table-column>
      <!--			<el-table-column label="是否有保险 1=是 0=否" align="center" prop="isBaoxian"/>-->
      <!--			<el-table-column label="是否体检 1=是 0=否" align="center" prop="isTijian"/>-->

      <!--			<el-table-column label="保险证明路径" align="center" prop="baoxianUrl"/>-->
      <el-table-column label="体检证明" align="left" prop="tijianUrl" min-width="360px">
        <template #default="{row}">
          <viewer
            :images="row.tijianUrls"
            style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
            <img
              style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
              v-for="img in row.tijianUrls" :src="img" :key="img" alt=""/>
          </viewer>
        </template>
      </el-table-column>

      <el-table-column label="月子餐" align="left" prop="yueZiCanUrls" min-width="360px">
        <template #default="{row}">
          <viewer
            :images="row.yueZiCanUrls"
            style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
            <img
              style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
              v-for="img in row.yueZiCanUrls" :src="img" :key="img" alt=""/>
          </viewer>
        </template>
      </el-table-column>
      <el-table-column label="工作照片" align="left" prop="workUrls" min-width="360px">
        <template #default="{row}">
          <viewer
            :images="row.workUrls"
            style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
            <img
              style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
              v-for="img in row.workUrls" :src="img" :key="img" alt=""/>
          </viewer>
        </template>
      </el-table-column>
      <el-table-column label="评价照片" align="left" prop="evaluateUrls" min-width="360px">
        <template #default="{row}">
          <viewer
            :images="row.evaluateUrls"
            style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
            <img
              style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
              v-for="img in row.evaluateUrls" :src="img" :key="img" alt=""/>
          </viewer>
        </template>
      </el-table-column>
      <el-table-column
        label="体检更新时间"
        align="center"
        prop="tijianTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column
        label="保险更新时间"
        align="center"
        prop="baoxianTime"
        :formatter="dateFormatter"
        width="180px"
      />
      <el-table-column label="保险证明" align="left" prop="baoxianUrls" min-width="360px">
        <template #default="{row}">
          <viewer
            :images="row.baoxianUrls"
            style="display:flex; align-items: center;align-items: center; flex-wrap: wrap">
            <img
              style="width: 100px; height: 100px; object-fit: contain; margin: 8px 8px 0 0; border: 1px dashed #ccc;"
              v-for="img in row.baoxianUrls" :src="img" :key="img" alt=""/>
          </viewer>
        </template>
      </el-table-column>
      <!--			<el-table-column label="身份证号" align="center" prop="identityNumber"/>-->
      <!--			<el-table-column label="是否背调" align="center" prop="isBeidiao"/>-->
      <!--			<el-table-column-->
      <!--				label="背调时间"-->
      <!--				align="center"-->
      <!--				prop="beidiaoTime"-->
      <!--				:formatter="dateFormatter"-->
      <!--				width="180px"-->
      <!--			/>-->
      <!--			<el-table-column-->
      <!--				label="创建时间"-->
      <!--				align="center"-->
      <!--				prop="createTime"-->
      <!--				:formatter="dateFormatter"-->
      <!--				width="180px"-->
      <!--			/>-->
      <el-table-column label="操作" align="center" fixed="right" min-width="180px">
        <template #default="scope">
          <el-button
            link
            type="primary"
            @click="openForm('update', scope.row.id)"
          >
            编辑
          </el-button>
          <el-button
            v-if="scope.row.banned"
            link
            type="primary"
            @click="handleCancelBanned(scope.row.id)"
          >
            解封
          </el-button>
          <el-button
            v-else
            link
            type="danger"
            @click="handleBanned(scope.row.id)"
          >
            拉黑
          </el-button>
          <el-button
            link
            type="danger"
            @click="handleDelete(scope.row.id)"
          >
            删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页 -->
    <Pagination
      :total="total"
      v-model:page="queryParams.pageNo"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />
  </ContentWrap>

  <!-- 表单弹窗：添加/修改 -->
  <ResumeForm ref="formRef" @success="getList"/>
</template>

<script setup lang="ts">
import {dateFormatter} from '@/utils/formatTime'
import download from '@/utils/download'
import * as ResumeApi from '@/api/yuesao/resume'
import ResumeForm from './ResumeForm.vue'
import {getRequestUrl} from "@/utils/env";
import {ElMessageBox, UploadProps} from "element-plus";
import {HEADERS} from "@/views/mp/material/components/upload";
import {isEmpty} from "lodash-es";

defineOptions({name: 'Resume'})

const message = useMessage() // 消息弹窗
const {t} = useI18n() // 国际化

const loading = ref(true) // 列表的加载中
const total = ref(0) // 列表的总页数
const list = ref([]) // 列表的数据
const queryParams = reactive({
  pageNo: 1,
  pageSize: 10,
  name: '',
  id: undefined,
  // avatar: null,
  // wechat: null,
  // mobile: null,
  // schoolDegree: null,
  // workHistory: null,
  // workSkill: null,
  // expectedSalary: null,
  // age: null,
  // origin: null,
  // hasChildren: null,
  // workYear: null,
  // nation: null,
  // selfIntro: null,
  // selfRemarks: null,
  // isBaoxian: null,
  // isTijian: null,
  // baoxianUrl: null,
  // baoxianTime: [],
  // tijianUrl: null,
  // tijianTime: [],
  // identityNumber: null,
  // isBeidiao: null,
  // beidiaoTime: [],
  // createTime: []
})
const queryFormRef = ref() // 搜索的表单
const exportLoading = ref(false) // 导出的加载中

/** 查询列表 */
const getList = async () => {
  loading.value = true
  try {
    const data = await ResumeApi.getResumePage(queryParams)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.pageNo = 1
  getList()
}

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value.resetFields()
  handleQuery()
}

/** 添加/修改操作 */
const formRef = ref()
const openForm = (type: string, id?: number) => {
  formRef.value.open(type, id)
}

/** 删除按钮操作 */
const handleDelete = async (id: number) => {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ResumeApi.deleteResume(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch {
  }
}

const handleBanned = async (id: number) => {
  try {
    await message.confirm('是否确认拉黑该月嫂')
    await ResumeApi.bannedResume(id)
    message.success('拉黑成功')
    // 刷新列表
    await getList()
  } catch {
  }
}
const handleCancelBanned = async (id: number) => {
  try {
    await message.confirm('是否确认解封该月嫂')
    await ResumeApi.cancelBannedResume(id)
    message.success('解封成功')
    // 刷新列表
    await getList()
  } catch {
  }
}

// 导入
const handleImportSuccess: UploadProps['onSuccess'] = (
  response,
  uploadFile
) => {
  if (response.code !== 0 || !response.data) {
    ElMessage.error(response.msg || '导入失败')
    return
  }

  const {failureUsernames, createUsernames} = response.data
  if (!isEmpty(failureUsernames)) {
    ElMessageBox.confirm(`导入成功：${JSON.stringify(createUsernames, null, 4)}， 导入失败:${JSON.stringify(failureUsernames, null, 4)}`, '提示', {
      confirmButtonText: '确 认',
      cancelButtonText: '取 消'
    }).then(getList)
  }
}

const downloadTemplate = async () => {
  try {
    window.open('/admin-api//yuesao/yuesao/downloadYuesaoTemplate', '_blank')
  } catch {
    //s
  }
}
/** 导出按钮操作 */
const handleExport = async () => {
  try {
    // 导出的二次确认
    await message.exportConfirm()
    // 发起导出
    exportLoading.value = true
    const data = await ResumeApi.exportResume(queryParams)
    download.excel(data, '月嫂简历.xls')
  } catch {
  } finally {
    exportLoading.value = false
  }
}

/** 初始化 **/
onMounted(() => {
  getList()
})
</script>
